//CN[h_dxCu
#include "DxLib.h"

//CN[h_[J
#include "Keyboard.h"
#include "Puzzle.h"

//CN[h_W
#include <stdlib.h>
#include <time.h>

//}N
#define BLOCK_SIZE 100
#define PAZZLE_PIECE_NUM 16
#define NUM_ZERO 0
#define NUM_BLACKBOX 15

//O[oϐ
static Puzzle_t Puzzle;

//֐`
void swap(int *a, int *b){
	
	int temp = *a;
	*a = *b;
	*b = temp;
}

// 
void Puzzle_Initialize(){
	
	int i;
	int a, b;

	for (i = 0; i < PAZZLE_PIECE_NUM; i++)
	{
		Puzzle.Place[i] = i;
	}

	srand((unsigned)time(NULL));
	
	for (i = PAZZLE_PIECE_NUM - 1; i > 1; i--)
	{
		a = i;
		b = rand() % i;
		swap(&Puzzle.Place[a], &Puzzle.Place[b]);
	}

	LoadDivGraph("C:/Documents and Settings/All Users/Documents/My Pictures/Sample Pictures/16puzzle01.png", 16, 4, 4, BLOCK_SIZE, BLOCK_SIZE, Puzzle.GrHandle);
	
}
// vZ
void Puzzle_Update(int MouseX, int MouseY){
	
	int click_blook_place;
	int i;
	
	if (0 <= MouseX && MouseX < 4 * BLOCK_SIZE && 0 <= MouseY && MouseY < 4 * BLOCK_SIZE )
	{
		click_blook_place = MouseX / 100 + MouseY / 100 * 4;
	
	} else {
		return;
	}
	
	int up = 0;
	int down = 0;
	int left = 0;
	int right = 0;

	up = click_blook_place - 4;
	
	if (up >= 0 && up == Puzzle.Place[NUM_BLACKBOX])
	{
		for (i = 0; i < sizeof(Puzzle.GrHandle)/sizeof(Puzzle.GrHandle[NUM_ZERO]); i++)
		{
			if (Puzzle.Place[i] == click_blook_place)
			{
				swap(&Puzzle.Place[i], &Puzzle.Place[NUM_BLACKBOX]);
				return;
			}
		}
	}

	down = click_blook_place + 4;

	if (down >= 0 && down == Puzzle.Place[NUM_BLACKBOX])
	{
		for (i = 0; i < sizeof(Puzzle.GrHandle)/sizeof(Puzzle.GrHandle[NUM_ZERO]); i++)
		{
			if (Puzzle.Place[i] == click_blook_place)
			{
				swap(&Puzzle.Place[i], &Puzzle.Place[NUM_BLACKBOX]);
				return;
			}
		}
	}

	if (click_blook_place % 4 == 0)left = -1;
	else left = click_blook_place - 1;

	if (left >= 0 && left == Puzzle.Place[NUM_BLACKBOX])
	{
		for (i = 0; i < sizeof(Puzzle.GrHandle)/sizeof(Puzzle.GrHandle[NUM_ZERO]); i++)
		{
			if (Puzzle.Place[i] == click_blook_place)
			{
				swap(&Puzzle.Place[i], &Puzzle.Place[NUM_BLACKBOX]);
				return;
			}
		}
	}

	if (click_blook_place % 4 == 3)right = -1;
	else right = click_blook_place + 1;

	if (right >= 0 && right == Puzzle.Place[NUM_BLACKBOX])
	{
		for (i = 0; i < sizeof(Puzzle.GrHandle)/sizeof(Puzzle.GrHandle[NUM_ZERO]); i++)
		{
			if (Puzzle.Place[i] == click_blook_place)
			{
				swap(&Puzzle.Place[i], &Puzzle.Place[NUM_BLACKBOX]);
				return;
			}
		}
	}
}

// ʂƔr
/*void Puzzle_Differ(){


}
*/	
	
// Ŝ`悷
void Puzzle_Draw(){
	int i;

	for (i = 0; i < sizeof(Puzzle.GrHandle)/sizeof(Puzzle.GrHandle[NUM_ZERO]); i++)
	{
		DrawGraph( BLOCK_SIZE * (Puzzle.Place[i] % 4), BLOCK_SIZE * (Puzzle.Place[i]/4), Puzzle.GrHandle[i], FALSE);
	}
}

//I
void Puzzle_Finalize(){
	
	int i;
	
	for (i = 0; i < sizeof(Puzzle.GrHandle)/sizeof(Puzzle.GrHandle[0]); i++)
	{
		DeleteGraph(Puzzle.GrHandle[i]);
	}
}