//CN[h_dxCu
#include "DxLib.h"

//CN[h_[J
#include "Keyboard.h"
#include "Mouse.h"
#include "Puzzle.h"


int WINAPI WinMain(HINSTANCE,HINSTANCE,LPSTR,int){

	int flag;
	
	int StringCr;

	ChangeWindowMode(true); 

	if (DxLib_Init() != 0)
	{
		flag = MessageBox(
                NULL ,
                TEXT("DxLib_Init() err") ,
                TEXT("Err") , 
                MB_OK);
		if (flag == IDOK) return -1;
	}

	SetMouseDispFlag( TRUE ) ;

	if (SetDrawScreen(DX_SCREEN_BACK) != 0)
	{
		flag = MessageBox(
				NULL ,
				TEXT("SetDrawScreen(DX_SCREEN_BACK) err") ,
				TEXT("Err") , 
				MB_OK);
					
		if (flag == IDOK){
			DxLib_End();
			return -1;
		}
	}

	// F̒l擾
	StringCr = GetColor( 255 , 255 , 255 ) ;

	Puzzle_Initialize();

	while( 1 ){
		if( ScreenFlip() != 0 ){
			flag = MessageBox(
					NULL ,
					TEXT("ScreenFlip err") ,
					TEXT("Err") , 
					MB_OK);
	
			if (flag == IDOK){
				break;
			}
		}
		if( ProcessMessage() != 0 ){
			flag = MessageBox(
					NULL ,
					TEXT("ProcessMessage err(End)") ,
					TEXT("Err") , 
					MB_OK);
	
			if (flag == IDOK){
				break;
			}
		}
		if( ClearDrawScreen() != 0 ){
			flag = MessageBox(
					NULL ,
					TEXT("ClearDrawScreen err") ,
					TEXT("Err") , 
					MB_OK);
	
			if (flag == IDOK){
				break;
			}
		}

/*		if( Keyboard_Update() != 0 ){
			flag = MessageBox(
					NULL ,
					TEXT("Keyboard_Update err") ,
					TEXT("Err") , 
					MB_OK);
	
			if (flag == IDOK){
				break;
			}
		}	
*/
		if( Mouse_Update() != 0 ){
			flag = MessageBox(
					NULL ,
					TEXT("Mouse_Update err") ,
					TEXT("Err") , 
					MB_OK);
	
			if (flag == IDOK){
				break;
			}
		}	
	
		if( ( Mouse_Get_Input() & MOUSE_INPUT_LEFT ) != 0 )
		{
			DrawFormatString( 400, 400, StringCr, "W w %d @x %d", Mouse_Get_X(), Mouse_Get_Y()) ;
			Puzzle_Update(Mouse_Get_X(), Mouse_Get_Y());
		}

		Puzzle_Draw();
	}

	Puzzle_Finalize();
	
	if (DxLib_End() != 0)
	{
		DrawFormatString(0, 0, GetColor(0, 0, 255), "DxLib_End err");
		return 0;
	}

	return 0;

}